Foreman - Bug #12452

Non admin users cant do bulk actions on hosts
11/12/2015 04:39 AM - Alon Goldboim

Status: Closed
Priority: Normal
Assignee: Alon Goldboim
Category: Rails
Target version: 1.10.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2905
Description

When trying to do balk action on hosts with non admin user causes:

| ActionView::Template::Error (PG::AmbiguousColumn: ERROR: column reference "id" is ambiguous

| LINE 1: ... (1) AND "hosts"."type" IN ('Host::Managed') AND (id IN ('5'...

I A

| : SELECT "hosts"."id" AS t0_r0O, "hosts"."name" AS tO_rl, "hosts"."last_compile" AS tO0O_

s"."last_report" AS t0_r3, "hosts"."updated_at" AS t0_r4, "hosts"."created_at" AS tO_r5,
root_pass" AS t0_r6, "hosts"."architecture_id" AS tO_r7, "hosts"."operatingsystem_id" AS
osts"."environment_id" AS t0_r9, "hosts"."ptable_id" AS t0_r10, "hosts"."medium_id" AS tO

r2, "host
Ilhostsll . n
t0_r8, "h

_rll, "ho

sts"."build" AS t0_rl2, "hosts"."comment" AS tO_rl13, "hosts"."disk" AS tO_rl4, "hosts"."installed_
at" AS tO_rl5, "hosts"."model_id" AS tO_rl6, "hosts"."hostgroup_id" AS t0_rl7, "hosts"."owner_id"
AS t0_r18, "hosts"."owner_type" AS t0_rl9, "hosts"."enabled" AS t0_r20, "hosts"."puppet_ca_proxy_i

d" AS t0_r21, "hosts"."managed" AS t0_r22, "hosts"."use_image" AS t0_r23, "hosts"."image_

file" AS

t0_r24, "hosts"."uuid" AS t0_r25, "hosts"."compute_resource_id" AS t0_r26, "hosts"."puppet_proxy_i
d" AS t0_r27, "hosts"."certname" AS t0_r28, "hosts"."image_id" AS t0_r29, "hosts"."organization_id

" AS t0_r30, "hosts"."location_id" AS t0_r31, "hosts"."type" AS t0_r32, "hosts"."otp" AS

t0_r33, "

hosts"."realm id" AS t0_r34, "hosts"."compute_profile_id" AS t0_r35, "hosts"."provision_method" AS
t0_r36, "hosts"."grub_pass" AS t0_r37, "hosts"."discovery_rule_id" AS t0_r38, "hosts"."global_sta
tus" AS t0_r39, "hosts"."lookup_value_matcher" AS t0_r40, "hostgroups"."id" AS tl_r0, "hostgroups"

."name" AS tl_rl, "hostgroups"."created_at" AS tl_r2, "hostgroups"."updated_at" AS tl_r3,
ups"."environment_id" AS tl_r4, "hostgroups"."operatingsystem_id" AS tl_r5, "hostgroups".
ture_id" AS tl_r6, "hostgroups"."medium_id" AS tl_r7, "hostgroups"."ptable_id" AS tl_r8,

ps"."root_pass" AS tl_r9, "hostgroups"."puppet_ca_proxy_id" AS tl_r10, "hostgroups"."use_

"hostgro
"architec
"hostgrou
image" AS

tl_rll, "hostgroups"."image_file"™ AS tl_rl2, "hostgroups"."ancestry" AS tl_rl13, "hostgroups"."vm_
defaults" AS tl_rl4, "hostgroups"."subnet_id" AS tl_rl5, "hostgroups"."domain_id" AS tl_rl6, "host

roups"."puppet_proxy_id" AS tl_rl7, "hostgroups"."title" AS tl_rl18, "hostgroups"."realm_
g P pupp P Y

id" AS tl1

_rl9, "hostgroups"."compute_profile_id" AS tl_r20, "hostgroups"."grub_pass" AS tl_r21l, "hostgroups
"."lookup_value_matcher" AS tl_r22, "environments"."id" AS t2_r0, "environments"."name" AS t2_rl,

"environments"."created_at" AS t2_r2, "environments"."updated_at" AS t2_r3, "environments"."hosts

count" AS t2_r4, "environments"."hostgroups_count" AS t2_r5, "taxonomies"."id" AS t3_r0,

"taxonomi

es"."name" AS t3_rl, "taxonomies"."type" AS t3_r2, "taxonomies"."created_at" AS t3_r3, "taxonomies

"."updated_at" AS t3_r4, "taxonomies"."ignore_types" AS t3_r5, "taxonomies"."ancestry" AS t3_ro6, "

taxonomies"."title" AS t3_r7, "taxonomies"."description" AS t3_r8, "locations_hosts"."id"

"locations_hosts"."name" AS t4_rl, "locations_hosts"."type" AS t4_r2, "locations_hosts".

_at" AS t4_r3, "locations_hosts"."updated_at" AS t4_r4, "locations_hosts"."ignore_types"

AS t4_r0
"created
AS t4_r5,

"locations_hosts"."ancestry" AS t4_r6, "locations_hosts"."title" AS t4_r7, "locations_hosts"."des
cription™ AS t4_r8 FROM "hosts" LEFT OUTER JOIN "hostgroups" ON "hostgroups"."id" = "hosts"."hostg

roup_id" LEFT OUTER JOIN "environments" ON "environments"."id" = "hosts"."environment_id"

LEFT OUT

ER JOIN "taxonomies" ON "taxonomies"."id" = "hosts"."organization_id" AND "taxonomies"."type" IN (

'Organization') LEFT OUTER JOIN "taxonomies" "locations_hosts" ON "locations_hosts"."id"

= "hosts"

."location_id" AND "locations_hosts"."type" IN ('Location') WHERE "hosts"."organization_id" IN (2)

AND "hosts"."location_id" IN (1) AND "hosts"."type" IN ('Host::Managed') AND (id IN ('5'

IN (NULL))):
| 20: <% associations = [:hostgroup, :environment] %>
| 21: <% associations << :organization if SETTINGS|[:organizations_enabled]
) or name

%>
22:
235
24:
25:
26:

<% associations << :location if SETTINGS[:locations_enabled] %>
<% hosts.includes (*associations) .each do |host]| %>
<tr>
<td><%=h host %>
</td>

app/views/hosts/multiple_build.html.erb:1:in ~_7709227ac525b2e63e519dc40c5fc266"
app/controllers/concerns/application_shared.rb:13:in "set_timezone'

app/models/concerns/foreman/thread_session.rb:32:in "clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in “call'

\
\
\
\
\
| app/views/hosts/_selected_hosts.html.erb:23:in °_43aeccl2a5aa4e08714fb03fd85fb355"
\
\
\
\
\

Related issues:

Related to Foreman - Bug #8048: n+1 query on select multiple hosts Closed 10/23/2014

Associated revisions

Revision 935bc248 - 12/08/2015 05:50 AM - Alon Goldboim

Fixes #12452 - Enable non admin users to do bulk actions on hosts

Revision 22ceff89 - 01/19/2016 08:16 AM - Alon Goldboim

Fixes #12452 - Enable non admin users to do bulk actions on hosts

(cherry picked from commit 935bc248287083b57¢1c2bdf68e59c5a0035a4af)

History

#1 - 11/12/2015 04:41 AM - Alon Goldboim

desc went bad

#2 - 11/12/2015 04:45 AM - Dominic Cleal

- Description updated

- Category set to Rails

Please just edit it then next time and wrap in pre tags.

#3 - 11/12/2015 04:46 AM - Dominic Cleal
- Related to Bug #8048: n+1 query on select multiple hosts added

#4 - 11/12/2015 05:11 AM - The Foreman Bot
- Status changed from New to Ready For Testing

- Assignee set to Alon Goldboim

- Pull request https://github.com/theforeman/foreman/pull/2905 added

#5 - 12/08/2015 05:51 AM - Dominic Cleal

- Subject changed from None admin users cant do balk actions on hosts to Non admin users cant do bulk actions on hosts

- translation missing: en.field_release set to 104

#6 - 12/08/2015 06:01 AM - Alon Goldboim
- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 935bc248287083b57c1c2bdf68e59c5a0035a4af.
